﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.ComponentModel;

namespace Samples.GridView.RowReorder
{
    public partial class RowReorderBehavior
    {
        public static readonly DependencyProperty DragCueStyleProperty =
            DependencyProperty.Register("DragCueStyle", typeof(Style), typeof(RowReorderBehavior), new PropertyMetadata(null, new PropertyChangedCallback(OnDragCueStylePropertyChanged)));

        public Style DragCueStyle
        {
            get { return (Style)GetValue(DragCueStyleProperty); }
            set { SetValue(DragCueStyleProperty, value); }
        }

        private static void OnDragCueStylePropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            RowReorderBehavior rowReorder = (RowReorderBehavior)sender;

            if (rowReorder.dragCue != null)
                rowReorder.dragCue.Style = rowReorder.DragCueStyle;
        }

        public DataTemplate DragCueActionContentTemplate
        {
            get { return (DataTemplate)GetValue(DragCueActionContentTemplateProperty); }
            set { SetValue(DragCueActionContentTemplateProperty, value); }
        }

        public static readonly DependencyProperty DragCueActionContentTemplateProperty =
            DependencyProperty.Register("DragCueActionContentTemplate", typeof(DataTemplate), typeof(RowReorderBehavior), new PropertyMetadata(null, new PropertyChangedCallback(OnDragCueActionContentTemplatePropertyChanged)));

        private static void OnDragCueActionContentTemplatePropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            RowReorderBehavior rowReorder = (RowReorderBehavior)sender;

            if (rowReorder.dragCue != null)
                rowReorder.dragCue.DragActionContentTemplate = rowReorder.DragCueActionContentTemplate;
        }

        public DataTemplate DragCueTooltipContentTemplate
        {
            get { return (DataTemplate)GetValue(DragCueTooltipContentTemplateProperty); }
            set { SetValue(DragCueTooltipContentTemplateProperty, value); }
        }

        public static readonly DependencyProperty DragCueTooltipContentTemplateProperty =
            DependencyProperty.Register("DragCueTooltipContentTemplate", typeof(DataTemplate), typeof(RowReorderBehavior), new PropertyMetadata(null, new PropertyChangedCallback(OnDragCueTooltipContentTemplatePropertyChanged)));

        private static void OnDragCueTooltipContentTemplatePropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            RowReorderBehavior rowReorder = (RowReorderBehavior)sender;

            if (rowReorder.dragCue != null)
                rowReorder.dragCue.DragTooltipContentTemplate = rowReorder.DragCueTooltipContentTemplate;
        }

        public DataTemplate DragCueItemTemplate
        {
            get { return (DataTemplate)GetValue(DragCueItemTemplateProperty); }
            set { SetValue(DragCueItemTemplateProperty, value); }
        }

        public static readonly DependencyProperty DragCueItemTemplateProperty =
            DependencyProperty.Register("DragCueItemTemplate", typeof(DataTemplate), typeof(RowReorderBehavior), new PropertyMetadata(null, new PropertyChangedCallback(DragCueItemTemplatePropertyChanged)));

        private static void DragCueItemTemplatePropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            RowReorderBehavior rowReorder = (RowReorderBehavior)sender;

            if (rowReorder.dragCue != null)
                rowReorder.dragCue.ItemTemplate = rowReorder.DragCueItemTemplate;
        }

        public bool PreserveSelectionOrderWhenReordering
        {
            get { return (bool)GetValue(PreserveSelectionOrderWhenReorderingProperty); }
            set { SetValue(PreserveSelectionOrderWhenReorderingProperty, value); }
        }

        public static readonly DependencyProperty PreserveSelectionOrderWhenReorderingProperty =
            DependencyProperty.Register("PreserveSelectionOrderWhenReordering", typeof(bool), typeof(RowReorderBehavior), new PropertyMetadata(false));
    }
}
